=== modified file 'bzrlib/add.py'
--- bzrlib/add.py	2005-10-17 23:13:00 +0000
+++ bzrlib/add.py	2005-10-28 04:34:46 +0000
@@ -24,6 +24,8 @@
 from bzrlib.osutils import quotefn
 
 def glob_expand_for_win32(file_list):
+    if not file_list:
+        return
     import glob
     expanded_file_list = []
     for possible_glob in file_list:

=== modified file 'bzrlib/lock.py'
--- bzrlib/lock.py	2005-09-23 12:49:00 +0000
+++ bzrlib/lock.py	2005-10-28 04:35:58 +0000
@@ -112,9 +112,9 @@
         import win32con, win32file, pywintypes
 
 
-        #LOCK_SH = 0 # the default
-        #LOCK_EX = win32con.LOCKFILE_EXCLUSIVE_LOCK
-        #LOCK_NB = win32con.LOCKFILE_FAIL_IMMEDIATELY
+        LOCK_SH = 0 # the default
+        LOCK_EX = win32con.LOCKFILE_EXCLUSIVE_LOCK
+        LOCK_NB = win32con.LOCKFILE_FAIL_IMMEDIATELY
 
         class _w32c_FileLock(_base_Lock):
             def _lock(self, filename, openmode, lockmode):
@@ -139,12 +139,13 @@
 
         class _w32c_ReadLock(_w32c_FileLock):
             def __init__(self, filename):
-                _w32c_FileLock._lock(self, filename, 'rb', 0)
+                _w32c_FileLock._lock(self, filename, 'rb',
+                                     LOCK_NB)
 
         class _w32c_WriteLock(_w32c_FileLock):
             def __init__(self, filename):
                 _w32c_FileLock._lock(self, filename, 'wb',
-                                     win32con.LOCKFILE_EXCLUSIVE_LOCK)
+                                     LOCK_EX + LOCK_NB)
 
 
 

=== modified file 'setup.py'
--- setup.py	2005-10-24 23:54:01 +0000
+++ setup.py	2005-10-28 04:31:55 +0000
@@ -5,45 +5,35 @@
 # './setup.py --help' for more options
 
 from distutils.core import setup
-
-# more sophisticated setup script, based on pychecker setup.py
-import sys, os
-from distutils.command.build_scripts import build_scripts
+from distutils.command.install_scripts import install_scripts
 
 
 ###############################
 # Overridden distutils actions
 ###############################
 
-class my_build_scripts(build_scripts):
-    """Customized build_scripts distutils action.
-
+class my_install_scripts(install_scripts):
+    """ Customized install_scripts distutils action.
     Create bzr.bat for win32.
     """
-
     def run(self):
+        import os
+        import sys
+
+        install_scripts.run(self)   # standard action
+
         if sys.platform == "win32":
-            bat_path = os.path.join(self.build_dir, "bzr.bat")
-            self.scripts.append(bat_path)
-            self.mkpath(self.build_dir)
-            scripts_dir = self.distribution.get_command_obj("install").\
-                                                            install_scripts
-            self.execute(func=self._create_bat,
-                         args=[bat_path, scripts_dir],
-                         msg="Create %s" % bat_path)
-        build_scripts.run(self) # invoke "standard" action
-
-    def _create_bat(self, bat_path, scripts_dir):
-        """ Creates the batch file for bzr on win32.
-        """
-        try:
-            script_path = os.path.join(scripts_dir, "bzr")
-            bat_str = "@%s %s %%*\n" % (sys.executable, script_path)
-            file(bat_path, "w").write(bat_str)
-            print "file written"
-        except Exception, e:
-            print "ERROR: Unable to create %s: %s" % (bat_path, e)
-            raise e
+            try:
+                scripts_dir = self.install_dir
+                script_path = os.path.join(scripts_dir, "bzr")
+                batch_str = "@%s %s %%*\n" % (sys.executable, script_path)
+                batch_path = script_path + ".bat"
+                f = file(batch_path, "w")
+                f.write(batch_str)
+                f.close()
+                print "Created:", batch_path
+            except Exception, e:
+                print "ERROR: Unable to create %s: %s" % (batch_path, e)
 
 
 ########################
@@ -67,4 +57,6 @@
                 'bzrlib.util.effbot.org',
                 'bzrlib.util.configobj',
                 ],
-      scripts=['bzr'])
+      scripts=['bzr'],
+      cmdclass={'install_scripts': my_install_scripts},
+     )

